#include <stdio.h>				/* standard I/O .h-file               */
#include <ctype.h>				/* character functions                */
#include <string.h>				/* string and memory functions        */
#include <stdlib.h>
#include <Display\reg552.h>
#include <rtx51.h>

#define	Dlzka		60		//pre 18.432MHz

sbit	LCD_RW	=	P4^0;
sbit	LCD_RS	=	P4^1;
sbit	LCD_EN	=	P4^2;

extern void Delay(unsigned char);

const unsigned char Riadok1=0x00,Riadok2=0x40;

xdata unsigned char Buffer[16+1];

sbit LCD7	=	P4^7;
sbit LCD6	=	P4^6;
sbit LCD5	=	P4^5;
sbit LCD4	=	P4^4;

void LCD_Clock(void)
{
 LCD_EN=1;
 Delay(Dlzka);
 LCD_EN=0;
}

void LCD_Send(unsigned char Data)
{
 LCD7=(Data&0x80)?1:0;		//Posielam MSB
 LCD6=(Data&0x40)?1:0;
 LCD5=(Data&0x20)?1:0;
 LCD4=(Data&0x10)?1:0;
 LCD_Clock();
 LCD7=(Data&0x08)?1:0;		//Posielam LSB
 LCD6=(Data&0x04)?1:0;
 LCD5=(Data&0x02)?1:0;
 LCD4=(Data&0x01)?1:0;
 LCD_Clock();
}

void LCD_Data(unsigned char Data)
{
 LCD_RS=1;  						//Pretoze odosielam data !!!
 LCD_EN=0;
 LCD_RW=0;
 LCD_Send(Data);
}

void LCD_Cmd(unsigned char Data)
{
 LCD_RS=0;							//Pretoze odosielam prikaz !!!
 LCD_EN=0;
 LCD_RW=0;
 LCD_Send(Data); 
}

void LCD_ClrScr(void)
{
 LCD_Cmd(0x01);
 os_wait(K_TMO,2,NULL);
}

void LCD_Goto(unsigned char Ptr)
{
 LCD_Cmd(0x80+Ptr);
 Delay(Dlzka);
}

void LCD_Home(void)
{
 LCD_Cmd(0x02);
 os_wait(K_TMO,2,NULL);
}

void LCD_Init(void)
{
 LCD_RS=0;
 LCD_RW=0;
 LCD_EN=0;

 os_wait(K_TMO,20,NULL);	//Cakaj cca. 20ms
 LCD_Cmd(0x33);
 os_wait(K_TMO,5,NULL);
 LCD_Cmd(0x32);
 os_wait(K_TMO,5,NULL); 
 LCD_Cmd(0x20+0x08);
 LCD_Cmd(0x10+0x00);
 LCD_Cmd(0x08+0x04);
 LCD_Cmd(0x04+0x02);
 LCD_ClrScr();
 LCD_Goto(Riadok1); 
 LCD_Home();
}

void LCD_Write_String(char *String)
{
 register unsigned char i;
 for(i=0x00; i<=sizeof(Buffer); i++)
  {
	 switch(*String)
		{
		 case	'\n'	:
		 case	'\r'	:
		 case	'\0'	:	*String=' '; break;
		}
		LCD_Data(*String++);
	}
 memset(Buffer,' ',sizeof(Buffer));	
}