#include <reg552.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <rtx51.h>

#define  MASK    0x07
#define	 MBXF		 0x01
#define	 MBXP		 0x02
#define	 MBXD		 0x03

#define  SERIAL  0x00
#define	 PHASE	 0x01
#define	 DISPLAY 0x02
#define	 ADC		 0x03

#define ADCS 0x08
#define ADCI 0x10
#define ADEX 0x20

typedef union ADC_Result
{
 unsigned int value:10;
 unsigned char seg[2];
}
ADC_Result;

enum {HI=0,LO=1} Typ;

xdata ADC_Result sample;				//xxx.value=10bit;

extern unsigned char Riadok1,Riadok2;
extern void LCD_Init(void);
extern void LCD_Write_String(char*);
extern void LCD_Goto(unsigned char);

typedef enum {NO_OK=0, YES_OK=1, DIR_R=2, DIR_L=4, DIR_C=8, DIR_N=16, DIR_W=32} Chyby;
typedef	enum {Seq6=6, Seq4=4, Seq2=2} Sekvencie;
typedef enum {OFF=0, ON=1} Stavy;
typedef enum {R=0, L=1} Smery;

unsigned char DIR;					//Vysledok zistenia tocenia sa faz ...
xdata	char Sekvencia[2];

sbit ERR  = P3^2;  					//ERR=0 je chyba, ERR=1 je OK
sbit LEDR = P3^3;  					//LED signalizujuca otacanie sa faz RIGHT
sbit LEDL = P3^4;  					//LED signalizujuca otacanie sa faz LEFT

sbit SL1	= P1^0;
sbit SL2	= P1^1;
sbit SL3	= P1^2;

unsigned char id;						//Identifikacia spusteneho tasku

bit Test;

char Buf[16+1];
float frekvencia;

typedef xdata struct																	//Musi byt deklarovana a pouzivana ako je to uvedene v tomto tvare, inac spravne nefunguje !!!
{
 unsigned int adc_value[8];														//Hodnoty jednotlivych ADC prevodnikov
 unsigned int phase[3];																//Hodnoty jednotlivych fazi
 float frequency[3];																	//Hodnoty jednotlivych f
}
Packet51;

xdata Packet51 Udaje;

void Serial(void) _task_ SERIAL _priority_ 0
{
 signed char RtxCompletion;
 float K = 18.432E6/24.0;															//T=(256*CTH0+CTL0)*(24/XTAL), T=(256*CTH0+CTL0)*(2/fosc),  f=1/T 
 unsigned int freq;																		//T=(256*CTH0+CTL0)*(24/XTAL), T=(256*CTH0+CTL0)*(2/fosc),  f=1/T
 PCON|=0x80;
 S0CON=0x50;
 TMOD|=0x20;
 TH1=TL1=0xFB;
 TR1=1;
 TI=1;
// printf("System Ready ...\r\n");
 printf("Please Wait ...\r\n");
 while(1)
  {
	 id=os_running_task_id();
   switch(RtxCompletion=os_wait(K_TMO+K_SIG+K_MBX+MBXF,250,&freq))
    {
     case MSG_EVENT : frekvencia=K/freq;
											sprintf(Buf,"f=%2.2fHz\r\n",frekvencia);
											printf("f=%2.2fHz, ---> ",frekvencia);
											break;
		 case TMO_EVENT :	switch(DIR)
												 {
													case	DIR_R	:	printf("Smer = RIGHT\r"); break;
													case	DIR_L	: printf("Smer = LEFT\r"); break;
												 }
											break;
     case SIG_EVENT : switch(DIR)	//Mam chybu a tak vypinam vsetky beziace tasky ...
											 {
												case	DIR_C	:	printf("MULTI-CAPTURE->L1+L2+L3\r\n"); break;
												case	DIR_N	:	printf("PHASE-NN\r\n"); break;
												case	DIR_W	:	printf("PHASE-OMEGA\r\n"); break;
												default			:	printf("UNKNOW ERROR\r\n"); break;
											 }
											os_detach_interrupt(6);
											os_detach_interrupt(7);
											os_detach_interrupt(8);
											os_delete_task(SERIAL);
											os_delete_task(PHASE);
											break;
    }
  }
}

#define	Timeout	30																										//Timeout na Error-y

#pragma REGISTERBANK(3)

void Phase(void) _task_ PHASE _priority_ 3														//Odporucana je aspon priorita 1 az 3, aby sa vsetko stihlo nacas ....
{
 signed char RtxCompletion;
 unsigned char i=0x00,Counter;
 unsigned int MailBox;
 unsigned int Temp,TempA,TempB,TempC,Delta;
 RtxCompletion=os_set_slice(1536); 
 TM2CON=0x01;																													//T2 s fosc/12
 CTCON|=0x20+0x10+0x08+0x04+0x02+0x01;
 ERR=YES_OK; DIR=DIR_N;
 RtxCompletion=os_attach_interrupt(6);																//Faza A - pripojim sa na nu prerusenim ...
 RtxCompletion=os_attach_interrupt(7);																//Faza B - pripojim sa na nu prerusenim ...
 RtxCompletion=os_attach_interrupt(8);																//Faza C - pripojim sa na nu prerusenim ...
 #ifdef RS232
 RtxCompletion=os_create_task(SERIAL);
 RtxCompletion=os_create_task(DISPLAY);
 RtxCompletion=os_create_task(ADC);
 #endif
 while(1)
  {
	 id=os_running_task_id();	
   switch(RtxCompletion=os_wait(K_INT+K_TMO+K_SIG+K_MBX+MBXP,Timeout,&MailBox))			//Cakam na fazu A,B,C a zachytavam obsahy zachytnych registrov ktore vyjadruju dlzku 1/2 periody fazoveho napatia siete
    {
     case	INT_EVENT	:	//Test=1;
											switch(TM2IR&MASK)
											 {
											  case	0x01	:	CTI0=0; if((Temp=(256*CTH0+CTL0))<TempA) Delta=65536-TempA+Temp; else Delta=Temp-TempA; TempA=Temp; break;
												case	0x02	:	CTI1=0; if((Temp=(256*CTH1+CTL1))<TempB) Delta=65536-TempB+Temp; else Delta=Temp-TempB; TempB=Temp; break;
												case	0x04	:	CTI2=0; if((Temp=(256*CTH2+CTL2))<TempC) Delta=65536-TempC+Temp; else Delta=Temp-TempC; TempC=Temp; break;
												default			: TM2IR&=~MASK; DIR=DIR_C; RtxCompletion=os_send_signal(PHASE); break;						//Tu by som sa nemal dostat ak spracujem tasky zmeny urovni nacas ....
											 }
											switch(Sekvencia[i]=(P1&MASK))
											 {
											  case	Seq6	: i++; break;
												case	Seq4	:	if(Sekvencia[1]==Seq4) DIR=DIR_R; LEDR=ON; LEDL=OFF; ERR=YES_OK; i=0x00; break;
												case	Seq2	:	if(Sekvencia[1]==Seq2) DIR=DIR_L; LEDL=ON; LEDR=OFF; ERR=YES_OK; i=0x00; break;
												default	:	i=0x00; break;
											 }
											if(++Counter==100) 
											 {
											  RtxCompletion=os_send_message(MBXF,Delta,1);	//Poslem informaciu o frekvencii cez mailbox ...
												Counter=0x00;
											 }	
											//Test=0;											
											break;																					//Prisla hrana fazy, tak vykonam toto ...
	   case	TMO_EVENT	:	RtxCompletion=os_send_signal(PHASE); break;			//Ak sa tu dostanem neprisla hrana fazy do TIME tak vyvolam chybu ...
		 case SIG_EVENT : LEDL=LEDR=OFF; ERR=NO_OK;
											RtxCompletion=os_send_signal(SERIAL);
											break;
		 case	MSG_EVENT	:	break;																					//Prijal som data z MailBox-u a spracujem ich ...
	  }
  }
}

#pragma REGISTERBANK(0)

void ADc(void) _task_ ADC _priority_ 0
{
 signed char RtxCompletion;
 RtxCompletion=os_attach_interrupt(10);
 ADCON|=(ADCS+1);
 while(1)
  {
   switch(RtxCompletion=os_wait(K_SIG+K_INT,0xFF,NULL))
    {
		 case	INT_EVENT	:	Test=1;
											switch(ADCH&0xC0)						//Dava spravny vysledok rutina v C za 23us s 8 stupnom optimalizacie v data !!!
											 {
											  case	0x40	:	sample.seg[HI]=0x01; break;
												case	0x80	:	sample.seg[HI]=0x02; break;
												case	0xC0	:	sample.seg[HI]=0x03; break;
											 }
											sample.seg[LO]=ADCH*4;			//Nizsia cast vysledku prevodu do premennej sample
											switch(ADCON&0xC0)
											 {
											  case	0x40	: sample.seg[LO]+=0x01; break;	
												case	0x80	: sample.seg[LO]+=0x02; break;
												case	0xC0	: sample.seg[LO]+=0x03; break;
											 }
											Test=0;
											ADCON|=(ADCS+1); 						//Spustim prevod ...
											//RtxCompletion=os_send_message(MBXD,sample.value,3);
											break;
		 case	TMO_EVENT	:	
		 case	SIG_EVENT	:	ADCON|=(ADCS+1); break;
		 case	SEM_EVENT	:	break;
		 case	MSG_EVENT	:	break;
	  } 
  }
}

#pragma REGISTERBANK(0)

void Display(void) _task_ DISPLAY _priority_ 0
{
 signed char RtxCompletion;
 unsigned int Result;
 LCD_Init();
 while(1)
  {
	 switch(RtxCompletion=os_wait(K_TMO+K_SIG+K_MBX+MBXD,250,(unsigned int xdata*)&Result))
	  {
		 case	TMO_EVENT	:
		 case	SIG_EVENT	:
		 case MSG_EVENT	: LCD_Goto(Riadok1);
											LCD_Write_String(Buf);
											break;
		}
	}
}

void main(void)
{
 signed char RtxCompletion;
 RtxCompletion=os_start_system(PHASE);
}